import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

import java.util.List;
import java.util.ArrayList;
import java.awt.Color;
import java.awt.Font;
import java.util.Calendar;

/**
 * Un ours peut se déplacer sur une surface en fonction des touches pressées.
 * 
 * @author Bernard Gisin
 * @version 0.1
 */
public class cOurs extends Actor
{
    private static final int NORTH = 1;
    private static final int EAST  = 2;
    private static final int SOUTH = 3;
    private static final int WEST  = 4;

    private int direction = EAST;

    public cOurs()
    {
        direction = EAST;
    }

    /**
     * act()  est appelé plusieurs fois par secondes.
     * C'est a travers lui que les événements sont testés.
     */
    public void act()
    {
        processKeys();
    }
    
    /**
     * Se déplace en fonction des touches pressées
     */
    private void processKeys() {
        if(Greenfoot.isKeyDown("up")) {
            move();
        }    
    }

   /**
     * Avance l'ours dans la direction courante.
     */
    public void move()
    {
        if (!canMove()) {
            return;
        }
                
        setLocation(getX()+1, getY());
    }

    /**
     * Test si l'ours peut se déplacer.
     * S'il le peut, returne true sinon retourne false.
     */
    public boolean canMove()
    {
        World myWorld = getWorld();
        int x = getX();
        int y = getY();
        switch(direction) {
            case SOUTH :
                y++;
                break;
            case EAST :
                x++;
                break;
            case NORTH :
                y--;
                break;
            case WEST :
                x--;
                break;
        }
        // test for outside border
        if (x >= myWorld.getWidth() || y >= myWorld.getHeight()) {
            return false;
        }
        else if (x < 0 || y < 0) {
            return false;
        }
        return true;
    }   
}